## net.sf.saxon.expr.instruct
Class ComputedElement

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.instruct.Instruction
              net.sf.saxon.expr.instruct.ParentNodeConstructor
                  net.sf.saxon.expr.instruct.ElementCreator
                      net.sf.saxon.expr.instruct.ComputedElement

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, DivisibleInstruction, TailCallReturner, SequenceIterable, InstructionInfo, Locator

    public class ComputedElement

extends ElementCreator

An instruction representing an xsl:element element in an XSLT stylesheet, or a computed element constructor in XQuery. (In both cases, if the element name is expressed as a compile-time expression, then a FixedElement instruction is used instead.)

See Also:
  `FixedElement`, Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.instruct.ElementCreator
`inheritNamespaces, preservingTypes`

Fields inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor
`content`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`ComputedElement(Expression elementName, Expression namespace, NamespaceResolver nsContext, SchemaType schemaType, int validation, boolean inheritNamespaces, boolean allowQName)` Create an instruction that creates a new element node

Method Summary
`void` `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`Expression` `copy()` Copy an expression.
`void` `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`int` `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
`ItemType` `getItemType(TypeHierarchy th)` Get the item type of the value returned by this instruction
`int` `getNameCode(XPathContext context, NodeInfo copiedNode)` Callback from the superclass ElementCreator to get the nameCode for the element name
`Expression` `getNameExpression()` Get the expression used to compute the element name
`Expression` `getNamespaceExpression()` Get the expression used to compute the namespace URI
`NamespaceResolver` `getNamespaceResolver()` Get the namespace resolver that provides the namespace bindings defined in the static context
`String` `getNewBaseURI(XPathContext context, NodeInfo copiedNode)` Get the base URI for the element being constructed
`Iterator<Expression>` `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`Expression` `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`protected void` `outputNamespaceNodes(XPathContext context, Receiver out, int nameCode, NodeInfo copiedNode)` Callback to output namespace nodes for the new element.
`protected void` `promoteInst(PromotionOffer offer)` Offer promotion for subexpressions.
`boolean` `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`Expression` `simplify(ExpressionVisitor visitor)` Simplify an expression.
`Expression` `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Perform type checking of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.expr.instruct.ElementCreator
`checkContentSequence, computeSpecialProperties, evaluateItem, getActiveNamespaces, getImplementationMethod, isInheritNamespaces, isPreservingTypes, iterateEvents, iterateEvents, processLeavingTail, processLeavingTail, processLeft, processLeft, processRight, setValidationMode, suppressValidation`

Methods inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor
`addToPathMap, computeCardinality, createsNewNodes, getBaseURI, getCardinality, getContentExpression, getSchemaType, getValidationMode, isLazyConstruction, isNamespaceSensitive, setBaseURI, setContentExpression, setLazyConstruction, setSchemaType`

Methods inherited from class net.sf.saxon.expr.instruct.Instruction
`assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getConstructType, getExpressionName, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, iterate, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression

`adoptChildExpression, checkForUpdatingSubexpressions, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateSameFocusSubExpressions, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, toString, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### ComputedElement

    public ComputedElement(Expression elementName,
                           Expression namespace,
                           NamespaceResolver nsContext,
                           SchemaType schemaType,
                           int validation,
                           boolean inheritNamespaces,
                           boolean allowQName)

  Create an instruction that creates a new element node

  Parameters:
    `elementName` - Expression that evaluates to produce the name of the element node as a lexical QName
    `namespace` - Expression that evaluates to produce the namespace URI of the element node. Set to null if the namespace is to be deduced from the prefix of the elementName.
    `nsContext` - Saved copy of the static namespace context for the instruction. Can be set to null if namespace is supplied. This namespace context must resolve the null prefix correctly, based on the different rules for XSLT and XQuery. //* @param defaultNamespace Default namespace to be used if no namespace is supplied and the //* computed element is a string with no prefix.
    `validation` - Required validation mode (e.g. STRICT, LAX, SKIP)
    `inheritNamespaces` - true if child elements automatically inherit the namespaces of their parent
    `schemaType` - The required schema type for the content
    `allowQName` - True if the elementName expression is allowed to return a QNameValue; false if it must return a string, and is cast to a string if necessary (that is, true in XQuery, false in XSLT).

Method Detail

### getNameExpression

    public Expression getNameExpression()

  Get the expression used to compute the element name

  Returns:
    the expression used to compute the element name

### getNamespaceExpression

    public Expression getNamespaceExpression()

  Get the expression used to compute the namespace URI

  Returns:
    the expression used to compute the namespace URI

### getNamespaceResolver

    public NamespaceResolver getNamespaceResolver()

  Get the namespace resolver that provides the namespace bindings defined in the static context

  Returns:
    the namespace resolver

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Description copied from class: `ParentNodeConstructor`
  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Overrides:
    `simplify` in class `ParentNodeConstructor`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Description copied from class: `Expression`
  Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

  If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

  Overrides:
    `typeCheck` in class `ParentNodeConstructor`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `ParentNodeConstructor`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the item type of the value returned by this instruction

  Overrides:
    `getItemType` in class `ElementCreator`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the item type

### iterateSubExpressions

    public Iterator<Expression> iterateSubExpressions()

  Description copied from class: `ParentNodeConstructor`
  Get the immediate sub-expressions of this expression.

  Overrides:
    `iterateSubExpressions` in class `ParentNodeConstructor`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Overrides:
    `replaceSubExpression` in class `ParentNodeConstructor`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### promoteInst

    protected void promoteInst(PromotionOffer offer)
                        throws XPathException

  Offer promotion for subexpressions. The offer will be accepted if the subexpression is not dependent on the factors (e.g. the context item) identified in the PromotionOffer. By default the offer is not accepted - this is appropriate in the case of simple expressions such as constant values and variable references where promotion would give no performance advantage. This method is always called at compile time.

  Overrides:
    `promoteInst` in class `ParentNodeConstructor`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Throws:
    `XPathException` - if any error is detected

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Parameters:
    `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
    `env` - the static context
    `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
  Throws:
    `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

### getNameCode

    public int getNameCode(XPathContext context,
                           NodeInfo copiedNode)
                    throws XPathException

  Callback from the superclass ElementCreator to get the nameCode for the element name

  Specified by:
    `getNameCode` in class `ElementCreator`
  Parameters:
    `context` - The evaluation context (not used)
    `copiedNode` -
  Returns:
    the name code for the element name
  Throws:
    `XPathException` - if a failure occurs

### getNewBaseURI

    public String getNewBaseURI(XPathContext context,
                                NodeInfo copiedNode)

  Description copied from class: `ElementCreator`
  Get the base URI for the element being constructed

  Specified by:
    `getNewBaseURI` in class `ElementCreator`
  Parameters:
    `context` - the XPath dynamic evaluation context
    `copiedNode` - the node being copied (for xsl:copy), otherwise null
  Returns:
    the base URI of the constructed element

### outputNamespaceNodes

    protected void outputNamespaceNodes(XPathContext context,
                                        Receiver out,
                                        int nameCode,
                                        NodeInfo copiedNode)
                                 throws XPathException

  Callback to output namespace nodes for the new element.

  Specified by:
    `outputNamespaceNodes` in class `ElementCreator`
  Parameters:
    `context` - The execution context
    `out` - the Receiver where the namespace nodes are to be written
    `nameCode` -
    `copiedNode` -
  Throws:
    `XPathException`

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes

  Overrides:
    `getInstructionNameCode` in class `Instruction`
  Returns:
    a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.